function _typeof(o) { "@babel/helpers - typeof"; return _typeof = "function" == typeof Symbol && "symbol" == typeof Symbol.iterator ? function (o) { return typeof o; } : function (o) { return o && "function" == typeof Symbol && o.constructor === Symbol && o !== Symbol.prototype ? "symbol" : typeof o; }, _typeof(o); }
function ownKeys(e, r) { var t = Object.keys(e); if (Object.getOwnPropertySymbols) { var o = Object.getOwnPropertySymbols(e); r && (o = o.filter(function (r) { return Object.getOwnPropertyDescriptor(e, r).enumerable; })), t.push.apply(t, o); } return t; }
function _objectSpread(e) { for (var r = 1; r < arguments.length; r++) { var t = null != arguments[r] ? arguments[r] : {}; r % 2 ? ownKeys(Object(t), !0).forEach(function (r) { _defineProperty(e, r, t[r]); }) : Object.getOwnPropertyDescriptors ? Object.defineProperties(e, Object.getOwnPropertyDescriptors(t)) : ownKeys(Object(t)).forEach(function (r) { Object.defineProperty(e, r, Object.getOwnPropertyDescriptor(t, r)); }); } return e; }
function _defineProperty(obj, key, value) { key = _toPropertyKey(key); if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }
function _toPropertyKey(t) { var i = _toPrimitive(t, "string"); return "symbol" == _typeof(i) ? i : String(i); }
function _toPrimitive(t, r) { if ("object" != _typeof(t) || !t) return t; var e = t[Symbol.toPrimitive]; if (void 0 !== e) { var i = e.call(t, r || "default"); if ("object" != _typeof(i)) return i; throw new TypeError("@@toPrimitive must return a primitive value."); } return ("string" === r ? String : Number)(t); }
function _slicedToArray(arr, i) { return _arrayWithHoles(arr) || _iterableToArrayLimit(arr, i) || _unsupportedIterableToArray(arr, i) || _nonIterableRest(); }
function _nonIterableRest() { throw new TypeError("Invalid attempt to destructure non-iterable instance.\nIn order to be iterable, non-array objects must have a [Symbol.iterator]() method."); }
function _unsupportedIterableToArray(o, minLen) { if (!o) return; if (typeof o === "string") return _arrayLikeToArray(o, minLen); var n = Object.prototype.toString.call(o).slice(8, -1); if (n === "Object" && o.constructor) n = o.constructor.name; if (n === "Map" || n === "Set") return Array.from(o); if (n === "Arguments" || /^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(n)) return _arrayLikeToArray(o, minLen); }
function _arrayLikeToArray(arr, len) { if (len == null || len > arr.length) len = arr.length; for (var i = 0, arr2 = new Array(len); i < len; i++) arr2[i] = arr[i]; return arr2; }
function _iterableToArrayLimit(r, l) { var t = null == r ? null : "undefined" != typeof Symbol && r[Symbol.iterator] || r["@@iterator"]; if (null != t) { var e, n, i, u, a = [], f = !0, o = !1; try { if (i = (t = t.call(r)).next, 0 === l) { if (Object(t) !== t) return; f = !1; } else for (; !(f = (e = i.call(t)).done) && (a.push(e.value), a.length !== l); f = !0); } catch (r) { o = !0, n = r; } finally { try { if (!f && null != t.return && (u = t.return(), Object(u) !== u)) return; } finally { if (o) throw n; } } return a; } }
function _arrayWithHoles(arr) { if (Array.isArray(arr)) return arr; }
import React, { useMemo, useRef, useImperativeHandle, forwardRef } from 'react';
import useComponents from "../../../../hooks/useComponents";
import { updateBookingFormStorage, currentAppointmentBoard } from "../../utils";
import { useAppointmentBookingContext } from "../../context";
import { useAppointmentBookingResource, useAppointmentBookingSetting, useAppointmentBookingStep, useAppointmentBookingLogin, useAppointmentBookingAccount } from "../../hooks";
import { updateRelationForms } from "./utils";
import "./index.less";
var Form = /*#__PURE__*/forwardRef(function (props, ref) {
  var manualRef = useRef();
  var _ref = useAppointmentBookingContext(),
    appointmentBooking = _ref.appointmentBooking,
    setLoading = _ref.setLoading,
    currentStepParams = _ref.currentStepParams,
    carts = _ref.carts;
  var _useAppointmentBookin = useAppointmentBookingResource(),
    getResourceList = _useAppointmentBookin.getResourceList;
  var _useAppointmentBookin2 = useAppointmentBookingSetting(),
    setOtherData = _useAppointmentBookin2.setOtherData,
    getOtherData = _useAppointmentBookin2.getOtherData,
    isFormSubject = _useAppointmentBookin2.isFormSubject;
  var _useAppointmentBookin3 = useAppointmentBookingStep(),
    nextStep = _useAppointmentBookin3.nextStep;
  var _useAppointmentBookin4 = useAppointmentBookingLogin(),
    isLogin = _useAppointmentBookin4.isLogin;
  var _useAppointmentBookin5 = useAppointmentBookingAccount(),
    checkAccount = _useAppointmentBookin5.checkAccount;
  useImperativeHandle(ref, function () {
    return {
      next: function next() {
        var _stepLists, _manualRef$current, _manualRef$current$su;
        var stepLists = (currentStepParams === null || currentStepParams === void 0 ? void 0 : currentStepParams.stepLists) || [];
        var nextStepKey = (_stepLists = stepLists[(currentStepParams === null || currentStepParams === void 0 ? void 0 : currentStepParams.index) + 1]) === null || _stepLists === void 0 ? void 0 : _stepLists.key;
        // 如果下一步是确认页，则验证数据，有错误或者没有登录则不进行表单的提交

        // if (nextStepKey === 'confirm-information') {
        //   const { hasError } = checkAndGoNext(isFormSubject, checkAccount, carts);
        //   if (hasError || !isLogin) {
        //     return nextStep(formStatus);
        //   }
        // }

        setLoading(true);
        (_manualRef$current = manualRef.current) === null || _manualRef$current === void 0 || (_manualRef$current$su = _manualRef$current.submit) === null || _manualRef$current$su === void 0 || _manualRef$current$su.call(_manualRef$current);
      }
    };
  });
  var _useComponents = useComponents({
      components: ['FormCard']
    }),
    _useComponents2 = _slicedToArray(_useComponents, 1),
    FormCard = _useComponents2[0];
  var key = 'booking_form';

  // 获取本地存储
  var formStorage = getOtherData('booking_form') || {};
  var appointmentBoard = useMemo(function () {
    var _getResourceList = getResourceList(),
      resources = _getResourceList.resources;
    return currentAppointmentBoard(currentStepParams.key, resources, appointmentBooking);
  }, [currentStepParams.key]);
  var formId = useMemo(function () {
    return (appointmentBoard === null || appointmentBoard === void 0 ? void 0 : appointmentBoard.resource_form_id) || 0;
  }, [appointmentBoard === null || appointmentBoard === void 0 ? void 0 : appointmentBoard.resource_form_id]);

  /**
   * @title: 更新表单状态
   * @description:
   * @param {string} status
   * @return {*}
   * @Author: WangHan
   * @Date: 2025-04-26 18:39
   */
  var updateFormStatus = function updateFormStatus(status) {
    if (status === 'error') {
      setLoading(false);
    }
  };

  /**
   * @title: 设置表单存储
   * @description:
   * @param {any} values
   * @return {*}
   * @Author: WangHan
   * @Date: 2025-04-28 11:32
   */
  var setFormStorage = function setFormStorage(values) {
    var oldData = getOtherData(key);
    var newData = updateBookingFormStorage(oldData, currentStepParams === null || currentStepParams === void 0 ? void 0 : currentStepParams.key, values);
    setOtherData(key, _objectSpread({}, newData));

    // 更新表单购物车
    appointmentBooking.updateCart({
      _id: appointmentBoard === null || appointmentBoard === void 0 ? void 0 : appointmentBoard.cart_id,
      relationForms: updateRelationForms(carts, appointmentBoard, values, currentStepParams === null || currentStepParams === void 0 ? void 0 : currentStepParams.key)
    });
  };

  /**
   * @title: 表单设置成功之后的提交
   * @description:
   * @param {string} status
   * @param {any} values
   * @return {*}
   * @Author: WangHan
   * @Date: 2025-04-28 11:34
   */
  var handleFormFinish = function handleFormFinish(status, values) {
    try {
      updateFormStatus(status);
      if (status === 'success') {
        setFormStorage(values);
        nextStep();
      }
    } catch (error) {
      setLoading(false);
    }
  };
  return /*#__PURE__*/React.createElement(React.Fragment, null, /*#__PURE__*/React.createElement("div", {
    className: "appointment-form-wrap",
    key: currentStepParams === null || currentStepParams === void 0 ? void 0 : currentStepParams.key
  }, /*#__PURE__*/React.createElement(FormCard, {
    id: formId,
    ref: manualRef,
    isGetLastData: false,
    setting: {
      isHidden: 1
    },
    formWrapStyle: {
      padding: '16px'
    },
    isV2API: true,
    isShowSkeleton: true,
    onSubmit: function onSubmit(status, values) {
      handleFormFinish(status, values);
    },
    onFinishFailed: function onFinishFailed(e) {
      updateFormStatus('error');
    },
    onFormValueChange: function onFormValueChange(values) {},
    defaultValues: (formStorage === null || formStorage === void 0 ? void 0 : formStorage[currentStepParams === null || currentStepParams === void 0 ? void 0 : currentStepParams.key]) || {},
    isClearData: false
  })));
});
export default Form;